﻿Imports System.Drawing.Drawing2D

Public Class Form1
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        Dim y As Integer = 10
        Dim x As Integer = 10
        Dim wid As Integer = 200
        Dim hgt As Integer = 50

        ' Tworzy prostokąt, którego kolor przechodzi od czarnego do białego.
        e.Graphics.DrawString("Simple", Me.Font, Brushes.Black, x, y)
        y += 15
        Using black_white_brush As New  _
            LinearGradientBrush( _
                New Point(x, y), New Point(x + wid, y), _
                Color.Black, Color.White)
            e.Graphics.FillRectangle(black_white_brush, _
                x, y, wid, hgt)
            y += hgt + 10

            ' ColorBlend.
            e.Graphics.DrawString("ColorBlend", Me.Font, Brushes.Black, x, y)
            y += 15
            Dim color_blend As New ColorBlend(3)
            color_blend.Colors = New Color() {Color.Black, Color.White, Color.Black}
            color_blend.Positions = New Single() {0.0, 0.2, 1.0}
            black_white_brush.InterpolationColors = color_blend
            e.Graphics.FillRectangle(black_white_brush, _
                x, y, wid, hgt)
            y += hgt + 10

            ' Tworzy pędzel, w którym 50 procent koloru zmienia się
            ' na 20 pierwszych procentach powierzchni, pozostaje taki sam
            ' do 80. procenta i kończy na pozostałym obszarze.
            e.Graphics.DrawString("Blend", Me.Font, Brushes.Black, x, y)
            y += 15
            Dim the_blend As New Blend(4)
            the_blend.Factors = New Single() {0.0, 0.5, 0.5, 1.0}
            the_blend.Positions = New Single() {0.0, 0.2, 0.8, 1.0}
            black_white_brush.Blend = the_blend
            e.Graphics.FillRectangle(black_white_brush, _
                x, y, wid, hgt)
            y += hgt + 10

            ' Linia tego pędzla jest za krótka, aby przeciąć cały prostokąt.
            e.Graphics.DrawString("Short", Me.Font, Brushes.Black, x, y)
            y += 15
            Using short_brush As New  _
                LinearGradientBrush( _
                    New Point(x, y), New Point(x + 50, y), _
                    Color.Black, Color.White)
                e.Graphics.FillRectangle(short_brush, _
                    x, y, wid, hgt)
                y += hgt + 10

                x += wid + 10
                y = 10

                ' Zmienia tryb WrapMode pędzla.
                e.Graphics.DrawString("WrapMode = TileFlipX", Me.Font, _
                    Brushes.Black, x, y)
                y += 15
                short_brush.WrapMode = WrapMode.TileFlipX
                e.Graphics.FillRectangle(short_brush, _
                    x, y, wid, hgt)
                y += hgt + 10
            End Using ' short_brush

            ' Pędzel trójkątny.
            e.Graphics.DrawString("SetBlendTriangularShape", Me.Font, _
                Brushes.Black, x, y)
            y += 15
            black_white_brush.SetBlendTriangularShape(0.5)
            e.Graphics.FillRectangle(black_white_brush, _
                x, y, wid, hgt)
            y += hgt + 10

            ' Dzwon.
            e.Graphics.DrawString("SetSigmaBellShape", Me.Font, Brushes.Black, x, y)
            y += 15
            black_white_brush.SetSigmaBellShape(0.5, 1)
            e.Graphics.FillRectangle(black_white_brush, _
                x, y, wid, hgt)
            y += hgt + 10
        End Using ' black_white_brush

        ' Pędzel skośny.
        x += wid + 10
        y = 10
        wid = hgt
        e.Graphics.DrawString("Diagonal", Me.Font, Brushes.Black, x, y)
        y += 15
        Using diag_brush As New  _
            LinearGradientBrush( _
                New Point(x, y), New Point(x + wid, y + hgt), _
                Color.Black, Color.White)
            e.Graphics.FillRectangle(diag_brush, _
                x, y, wid, hgt)
            y += hgt + 10
        End Using
    End Sub
End Class
